CoCoALib - Feature #951

New function: IsSqFree
24 Oct 2016 17:19 - Anna Maria Bigatti

Status: Closed Start date: 24 Oct 2016

Priority: Normal Due date:

Assignee: John Abbott % Done: 100%

Category: New Function Estimated time: 11.10 hours

Target version: CoCoALib-0.99550 spring 2017 Spent time: 11.30 hours

Description

Write function IsSquareFree (or IsSqFr, or IsSgFree) for a RingElem

Related issues:

Related to CoCoALib - Feature #796: CoCoALib function for radical (or SgFree)... Closed 05 Nov 2015
Related to CoCoALib - Slug #952: GCD very slow Closed 25 Oct 2016
Related to CoCoALib - Support #953: new file for old functions: obsolescent.C Closed 26 Oct 2016

History

#1 - 24 Oct 2016 17:29 - Anna Maria Bigatti

- Subject changed from IsSquareFree to New function: IsSquareFree

Currently there is a function called IsRadical(PP) for a PPMonoidElem.

Should it be called IsSquareFree?

"A number is said to be squarefree (or sometimes quadratfrei; Shanks 1993) if its prime decomposition contains no repeated factors."

"The radical of any integer n, rad(n), is the largest square-free divisor of n"

This notation seems well-established in Number Theory, and it does make sense... (even though it is not what I'm used to)

#2 - 24 Oct 2016 17:31 - Anna Maria Bigatti

- Related to Feature #796: CoCoALib function for radical (or SqFree) of a polynomial added

#3 - 24 Oct 2016 17:51 - John Abbott
- Status changed from New to In Progress

- % Done changed from 0 to 10

A function which tests whether a value is square-free is probably going to be quite similar to a function which determines a factorization. It would be
nice to have a way to avoid duplicating the code for computing the factorization, but | do not currentlky see how to do this (without making a mess).

Probably the simplest (and quickest?) approach is just to duplicate the code, modify it so it simply says yes/no; then perhaps at the end see whether it

makes sense to remerge it with the factorization code.

Regarding names: in the file factor.H there is a function called SqFreeFactor, so to be consistent the test should be called IsSqFree (or we change

the name of SgFreeFactor).
#4 - 25 Oct 2016 23:01 - John Abbott

- Status changed from In Progress to Feedback
- Assignee set to John Abbott

- % Done changed from 10 to 90

| have checked in code for the new fn IsSqFree (incl. tests and doc).
It is not complete:

e currently gives error for polys with coeffs in ZZ (because it wants coeffs in a field)
o for integers with large prime factors it cannot decide (in CoCoALib return value is *bool3)

NOTE the special fn for PPs is still called IsRadical; should we rename it?

#5 - 25 Oct 2016 23:04 - John Abbott
- Related to Slug #952: GCD very slow added

#6 - 02 Nov 2016 18:17 - Anna Maria Bigatti

While comparing various implementations of radical(0-dim) | found this, unexpected for me:
IsSqgFree is quite fast on this example (not square-free) if poly ring is multivariate (ZZ/(101)[z,w]). If univariate, doesn't seem to terminate:

use 2ZZ/(101) [z];

MP := z"501 +43*z7499 +35%z7498 -25*z"497 +7*z"496 +31*z7495 -25%z7494 -11*z"493 -12*27492 -39*z7491 -48*z"490
—35*z7489 -34*z7488 +15*z7487 +50*z"486 —-23*z7485 -43*z7484 -24*z7483 +30%z7482 +22*z7481 -37*z"480 -12*z"479
+27*%z"478 +27*z7477 +49*%z"476 +29*z~475 +30*z"474 +17*z"473 -3*z7472 -42*%z"471 +41*z7470 -10*z"469 +13*z"468

+7%27°466 —8*z"465 -37*z"464 +27*%z27463 -43*z7462 +48*z"461 -46*z7460 -23*z7459 -10*z"458 +19*z7457 +5*z7456 -14

*z7455 —45*z7454 +38*z7453 +26*27452 +47*z"451 -30%z7450 +47*z"449 +29*z"448 +43*z7447 +32*z7446 —-44*z7445 +34

*z"444 -36*z"443 +36*z7442 -44*z7441 -36*z7440 -45*%z7439 +13*z7438 +13*z"437 -23*z7436 -33*z"435 —-4*z"434 -z"4

33 +50%27432 +23%z7431 —-43*z"430 -37%27429 -2%2z7428 +25%z7427 -29*z"426 -21*z7425 +18*z7424 +49*z"423 -14*z"42

2 +14*z7421 +15*%z27420 -7*z7419 +12*27418 —-45*z7417 -14*z7416 -32*z"415 -23*z"414 +22*z7413 +6*z7412 -37*z"411

-12*%z7410 +3*z7409 -23*z7408 +36*z"407 +17*z7406 -16*z"405 +43*z7404 +23*z7403 -30*z"402 +49*z"401 -11*z7400 +

21*27399 -45*%27398 -14*z7397 —-4*z"396 +22*z"395 -6*z"394 -47*z7393 +8*z7392 +11*z7391 +24*z"390 -15*z"389 +46*

z7388 —-17*z7387 +17*z27386 —47*z7385 +48*z27384 —-43*z"383 +48%*z7382 -47*z"381 —-46*z"380 +42*z"379 +33*z"378 -35*

z"377 -34*z"376 +33*z"375 +6*z"374 -18*z"373 -14*z"372 -35*z"371 -36*z"370 -31*z"369 -25*z"368 -7*z"367 +49*z"

366 —6*z7365 +47*z7364 -27*z"363 +42*z27362 -4*z7361 +14*z"360 +25*z"359 +26*z"358 +46*z"357 +35*z"356 +15*z"35

5 +17*z7354 -5*z7353 -10*z"352 +27*z7351 +15*z"350 +6*z"349 +28*z"348 -33*z"347 +14*2"346 -25*z"344 -4*z7343 -

23*z7342 +18%z7341 +6*z7340 -49*z"339 —-4*z"338 +44*z"337 +27*z7336 +19*z"335 -38*z"334 -31*z"333 +15*z"332 -28

*z7331 +41*z"330 +46*z7329 -34*%z7328 —-8*z"327 —-49*z"326 —-4*z"325 +10*z7324 +16*z"323 -37*z"322 +50*%z7321 +28*z

~320 +9*z7319 -23*z7318 +50*z7317 +14*z7316 —-42*z7315 +17*z27314 —-43*z"313 -30*z"312 +20*z"311 +40*z"309 -25*z"

308 +3*z7307 +12*z7306 +31*z"305 +47*z7304 +44*z"~303 -21*z"302 -6*z"301 -39*z"300 +45*z7299 +47*z"298 -49*z"729

7 =27*%27296 +5*z7295 +38%z7294 +35%z7293 +24*z7292 -37*%z7291 -2*z7290 +38*z7289 -40*z"288 +32*z"287 +32*z"286

—22*27285 —-8*z7284 +11*z7283 —-45*z7282 -28*z7281 +9*z7280 +22*z"7279 +32*z7278 -11*z"277 +50*%z7276 -17*z"275 +5

0*z"274 —17*z7273 -26*z7272 =30*z"271 -3*z"270 -3*z"269 +43*z7268 +13*z7267 +z"266 —-41*z7265 +14*z"264 +32*z"2

63 +43%z7262 —-z7261 +41*%z27260 -z"259 —-8*%z7258 +10*z"257 +39*z7256 +15*z7255 +4*z7254 -11*z"253 +22*z7252 -38*z

~251 +43*%z7250 —-34*z7249 +35*27248 -37*z"247 -28*z"246 +19*z7245 +7*z"244 -39%z7243 -15*z"242 -18*z"241 -27*z"

240 +19*%z7239 +24*z7238 +37*z7237 -21*z7236 —-22*z"235 +30%z7234 -28*z"233 -26*z"232 -26*z"231 +36*z"7230 —-43*z"

229 -13*%z7228 +15*z7227 +43*z7226 +28*z7225 +19*z"224 +28%z7223 -40*z"222 +30*z"221 -12*z7220 -41*z"219 -z"218
—6*z7217 -11*z7216 +14*z7215 -43*z7214 —-46*z"213 +23*z7212 +37*2z7211 —-45*z7210 +3*z"209 +46*z7208 -7*z7207 +3

T7*z7206 +34*z7205 +17*%z7204 +10*z7203 +35*z7202 -13*z7201 -25*z7200 +19*z"199 +32*z7198 -z7197 -37*z"196 +16*z

~195 -28%z7194 +7*%z7193 +16*z7192 +14*z7191 +34*z7190 -21*z"189 +22*z7188 -50*%z"187 +38*z7186 —-14*z"185 +23*z"

184 +z7183 -10*%z7182 +42*z7181 -13*z7180 -31*z"179 -33*z"178 +41*z"177 +4*z"176 —-42*z~175 +21*z"~174 +22*z"173

-9*z7172 -39*z7171 +10*z"170 -33*z"169 -33*z7168 +6*z7167 -20*z"7166 —-50*z"165 -29*z7164 +34*z"7163 —-47*z"162 -1

2*z7161 +z7160 -24*z7159 +23*z7158 +15*z"157 -30*z7156 +43*z"155 +16*z"154 -32*z7153 -48*z"152 +31*z"151 -45*z

~150 +28*z7149 +4*z7148 +2*z7147 +49*z7146 +29*z7145 -23*z7144 -17*z"143 —-45*z7142 +19*z7141 +46*z"7140 +6*z"13

9 +37*%z7138 +23*z7137 +23*z"136 -24*z7135 -z"134 +5*z"133 +39*z"132 +25*z7131 +48*z7130 -31*z"129 -2*z"128 -4*

z"127 +33%z7126 +43*z"125 +33*z7124 +6*z7123 +13*z7122 +43*z"121 +12*z7120 +9*z7119 -20*z"118 +z"117 +2*z"116

+5*z7115 -17*z7114 -z7113 -14*z7112 -19*z7111 -26*z"110 +23*z7109 -28*z7108 -36*z"107 +10*z"106 —-47*z"105 +16*

z7104 -19*z7103 -20*z"102 +20*z7101 -39*z"7100 +45*z"99 +42*z798 +15*z"97 -36*z"96 +40*z"95 -11*z"94 -24*z"93 -

21*z792 —-8*z791 +38*z790 -44*z789 -50*z788 +13*z787 +12*z786 +37*z"85 +46*z"84 +37*z"83 —-45*z782 +35*z781 -3*z

~80 +39*z779 —12*z778 +45*z777 +10*z"76 —22*z"75 —=25*z7T74 +20*z"73 —-2*z772 +18*z"71 +34*z770 +41*z769 -38*z"68
+19*z2767 —-49*z"°66 —-48*z"65 +47*z"64 -20*z"63 -31*z"62 —-8*z"61 -7*z760 -4*z"59 -19*z"58 -18*z"57 +28*z"56 +9*z
~"55 +49%z754 -13*z"53 +21*z"52 -14*z"51 +8*%z"50 +22*z749 -9*z"48 -18*z"47 —-43*z"46 +48*z"45 -11*z"44 +21*z"43
+45*%z742 +20*z~41 -10*z"40 +37*z"39 -49%z738 +5*z737 -23*z"36 +38*z"35 -13*z"34 +12*z"33 +32*z"32 -44*z"31 +19
*z730 —-25*z729 -21*z"28 -36*z"27 —-47*z726 +19*z"25 +17*z"24 -30*2z"23 +34*z722 +43*z"21 +5*z"20 +3*z"19 +15*z"1
8 —-36*z"17 +28*%z716 —-49*z"15 +23*z"14 -32*z"13 -10*z"12 -50*z"11 -29*z"10 +30*z"9 -30*z"8 +5*z"7 +34*z"6 +44*z
N5 =50*z™4 —44%z73 +44*%z72;

IsSgFree (MP) ;

#7 - 02 Nov 2016 18:23 - Anna Maria Bigatti

Reducing the example. These give segv:

Use 27/(101) [z];

MP := -19%*z"111 -26*z"110 +23*z7109 -28*z"108 -36*z"107 +10*z7106 —-47*z"105 +16*z"104 -19*z7103 -20*z"102 +20
*z7101 -39*z7100 +45*%z799 +42*%z798 +15*z"97 -36*z"96 +40*z795 -11*2z794 -24*z"93 -21*z"92 -8*%*z791 +38*z"90 -44*
z"89 -50%z788 +13*z787 +12*z786 +37*z785 +46*z784 +37*z783 -45*%z782 +35*z781 -3*z"80 +39*z"79 -12*z"78 +45*z"7
7 +10*z776 —22*z775 —25*z7T74 +20*z773 —-2*z772 +18*z"71 +34*z770 +41*z769 -38*z"68 +19*z"67 —-49*z"66 —-48*z"65 +
47*z7°64 -20*z"63 -31*z"62 -8*z"61 -7*z760 -4*z"59 -19*z"58 -18*z"57 +28*z"56 +9*z"55 +49*z"54 -13*z"53 +21*z"5
2 =14*z751 +8*z"50 +22*z"49 -9%z748 -18%*z"47 -43*z746 +48*z"45 —-11*z"44 +21*z743 +45*%z742 +20*z~41 -10*z~40 +3
7*z"39 -49%z738 +5*z737 -23*z736 +38*z735 -13*z734 +12*z733 +32*z732 -44*z731 +19*z730 -25*%z729 -21*z728 -36*z
~"27 —47%z726 +19*z725 +17*z724 -30%z"23 +34*z722 +43*z"21 +5*z"20 +3*z"19 +15*z718 -36*z"17 +28*z"16 —-49*z"15
+23*z714 -32*z713 -10*z"12 -50*z"11 -29*z"10 +30*z"9 -30*z"8 +5*z"7 +34*z"6 +44*z"5 —-50*z"4 —44*z"3 +44%2"°2;
IsSgFree (monic (MP)) ;

Use 27/(101) [z];
MP := —-23*z7408 +36*z7407 +17*z7406 —-16*z"405 +43*z7404 +23*z7403 -30*z"402 +49*z7401 -11*z"400 +21*z~399 -4
5%z7398 -14*2z"397 -4*z"396 +22*z7395 -6*27394 -47*z"393 +8*z7392 +11*z"391 +24*z7390 -15%z"389 +46*z"388 -17*z
~387 +17*%z7386 —-47*z"385 +48*27384 -43*z7383 +48*z"382 —-47*z"381 -46*z7380 +42*z"379 +33*2z7378 -35*z"377 -34*z
~"376 +33*z7375 +6*z7374 -18*z"373 -14*2z7372 -35*z7371 -36*z"370 -31*z"369 -25*%z7368 -7*z7367 +49*z"366 —-6*z"36
5 +47*z7364 -27*%z7363 +42*z"362 —-4*z"361 +14*z"360 +25*z7359 +26*z"358 +46*z"357 +35*z7356 +15*z"355 +17*z"354
—5%z7353 -10*2z"352 +27*z7351 +15%*z"350 +6*z"349 +28*2z7348 -33*2z7347 +14*z"346 -25*z"344 -4*z"343 -23*z7342 +1
8*z7341 +6*z"340 —-49%z7339 -4*z7338 +44*z2"337 +27*z7336 +19*z"335 -38*z7334 -31*z"333 +15*2"332 -28*z"331 +41*
27330 +46*z"°329 —-34*z7328 -8*z"327 -49*%z7326 —-4*z7325 +10*z"324 +16*2"323 -37*z7322 +50*z"321 +28*z"320 +9*z"3
19 -23%z7318 +50*2z7317 +14*z7316 —-42*z"315 +17*2z"314 -43*z7313 -30*z"312 +20*z"311 +40*z7309 -25*z"308 +3*z"30
7 +12*27306 +31*z7305 +47*z"304 +44*z"303 -21*z7302 -6*z7301 -39*z"300 +45*27299 +47*27298 —-49*z"297 -27*2"296
+5*%27295 +38*%2z7294 +35*z7293 +24*2z7292 -37*z"291 -2*z"290 +38*z"289 -40*z"288 +32*z7287 +32*z"286 —-22*z"285 -
8*2z7284 +11%z7283 —-45%z7282 -28*z7281 +9*2z7280 +22*2z7279 +32*z"278 —-11*2z"277 +50*%z7276 —-17*z"275 +50*z"274 -17
*z7273 —=26*z7272 -30%z7271 -3*z7270 —-3*z7269 +43*z"°268 +13*z"267 +2z7266 —41*z"265 +14*z2"264 +32*z7263 +43*z"26
2 -z7261 +41*z7260 -z"259 -8*z"258 +10*z"257 +39*z"256 +15*z7255 +4*z7254 -11*z"253 +22*z7252 -38*z"251 +43*z"
250 —-34*z"249 +35*27248 -37*z7247 -28*z"246 +19*z"245 +7*z"244 -39%z7243 -15*z"242 -18*z"241 -27*z7240 +19*z"2
39 +24%27238 +37*z7237 -21*27236 -22*z7235 +30*z"234 -28*z"233 -26*z"232 -26*z"231 +36*2z7230 -43*z7229 -13*z"2
28 +15*z7227 +43%z7226 +28*z"225 +19*z7224 +28*z7223 -40*z"222 +30*z"221 -12*z"220 -41*2z7219 -2z7218 -6*z"217 -
11*%z7216 +14*z7215 —-43*z7214 -46*z7213 +23*z"212 +37*2z7211 -45*%z7210 +3*z7209 +46*z"°208 —-7*z"207 +37*z"206 +34
*z7205 +17*z7204 +10*z7203 +35*z7202 -13*z"201 -25*z7200 +19*z"199 +32*2z7198 -2z7197 -37*z"196 +16*z"195 -28*z"
194 +7*%z7193 +16*z7192 +14*z7191 +34*z7190 -21*z"189 +22*z7188 -50*z"187 +38*z7186 -14*z"185 +23*z"184 +z"183
-10*2z7182 +42*z7181 —-13*z"180 -31*z"179 -33*z7178 +41*z"177 +4*z"176 —42*z"175 +21*z~174 +22*z"173 -9*z"~172 -3
9*z7171 +10*z7170 -33*z"169 -33*z"168 +6*z"167 -20*z7166 —-50*z"165 —-29*z"164 +34*z7163 —-47*z"162 -12*z"161 +z"
160 —-24%z7159 +23*z"158 +15*z7157 -30*z"156 +43*z"155 +16*z7154 -32*z"153 —-48*%*2z7152 +31*z"151 -45*z"150 +28*z"
149 +4*z7148 +2*z"147 +49*z7146 +29*z7145 -23*z"144 -17*2z7143 -45*%z7142 +19*z"141 +46*z"140 +6*2z"139 +37*z7138
+23*%z7137 +23*z7136 —-24*z7135 -z7134 +5*%z7133 +39*z"132 +25*z7131 +48%*2z7130 -31*z"129 -2*z"128 —-4*z"127 +33*z
2126 +43*%z7125 +33*z7124 +6*z7123 +13*27122 +43*z7121 +12*z7120 +9*z"~119 -20*2z~118 +z7117 +2*z~116 +5*z7115 -1
T*z~114 -2z7113 -14*z7112 -19*z"111 -26*z"110 +23*z7109 -28*z"108 -36*z"107 +10*z7106 -47*z"105 +16*z2"104 -19*z
2103 -20*%z7102 +20*z"101 -39*z"100 +45*z799 +42*z798 +15*%z797 -36*z796 +40*z795 -11*z794 -24*z793 -21*z792 -8*
z"91 +38*z790 -44*z"89 -50*%z"88 +13*z787 +12*z786 +37*z"85 +46*z"84 +37*z783 -45*z"82 +35*z"81 -3*z"80 +39*z"7
9 —-12%2z778 +45*%z777 +10*%z"76 —-22*z~75 —=25*%z~74 +20%z~73 -2*z"72 +18*z"71 +34*z"70 +41*z769 -38*z"68 +19*z"67 —
49*z27°66 —48*z"65 +47*z"64 -20*z"63 -31*z"62 -8*z"61 -7*z760 -4*z"59 -19*z"58 -18*z"57 +28*z"56 +9*z"55 +49*z"5
4 -13*z"53 +21*z"52 -14*z"51 +8*z"50 +22*z"49 -9*z"48 -18*z"47 —-43*z"46 +48*z"45 -11*z"44 +21*z"43 +45*z"42 +2
0*z"41 —-10*z"40 +37*2"39 —-49*2z738 +5*z"37 —-23*z"36 +38*z"35 —-13*z"34 +12*z"33 +32*z"32 —-44*z"31 +19*z"30 -25*z
~"29 —21%z728 -36*z727 —-47*%z"26 +19%z"25 +17*z"24 -30*z"23 +34*z"22 +43*z"21 +5*z720 +3*z"19 +15*z"18 -36*z"17
+28*%z716 —-49%z~15 +23*z"14 -32*z"13 -10*z"12 -50*z"11 -29*z"10 +30*z"9 -30*z"8 +5*z"7 +34*z"6 +44*z"5 -50*z"4
—44*z273 +44%272;
IsSgFree (monic (MP)) ;
#8 - 02 Nov 2016 18:58 - John Abbott
| believe | have fixed the SEGV bug. Checked in new version of DUPFp.C. @Anna: could you check? :-)

NOTE problem was calling SmallFpImpl::myExport instead of SmallFplmpl::myExportNonNeg

#9 - 02 Nov 2016 20:17 - Anna Maria Bigatti
John Abbott wrote:

I believe | have fixed the SEGV bug. Checked in new version of DUPFp.C. @Anna: could you check? :-)

Perfect, and faster than the multivariate case :-)

#10 - 02 Nov 2016 20:58 - Anna Maria Bigatti
John Abbott wrote:

NOTE the special fn for PPs is still called IsRadical; should we rename it?

yes, please (and make it obsolescent? ;-)

#11 - 02 Nov 2016 20:59 - Anna Maria Bigatti
- Related to Support #953: new file for old functions: obsolescent.C added

#12 - 07 Nov 2016 12:31 - John Abbott

| have renamed IsRadical (for PPMonoidElem)to IsSgFree. The old fn has been moved to obsolescent.C (see #953).
I'll check documentation -- OK, updated and checked in.

#13 - 07 Nov 2016 16:04 - Anna Maria Bigatti

- Subject changed from New function: IsSquareFree to New function: IsSqFree

Renamed AreGensSquareFreeMonomial into AreGensSqFreeMonomial.
Added to CoCoA-5 (with doc) and to obsolescent.C (and to test).

#14 - 18 Nov 2016 23:09 - John Abbott

- Status changed from Feedback to Closed
- % Done changed from 90 to 100

- Estimated time set to 11.10 h
